package com.jasamedika.medifirst2000.service.impl;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.stereotype.Service;

import com.jasamedika.medifirst2000.converter.BaseConverterImpl;
import com.jasamedika.medifirst2000.dao.PemeriksaanFisikDao;
import com.jasamedika.medifirst2000.dao.PenyulitAnestesiDao;
import com.jasamedika.medifirst2000.entities.KajianSistem;
import com.jasamedika.medifirst2000.entities.KlasifikasiASA;
import com.jasamedika.medifirst2000.entities.PemeriksaanFisik;
import com.jasamedika.medifirst2000.entities.PenyulitAnestesi;
import com.jasamedika.medifirst2000.entities.PraAnestesiDokter;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.PemeriksaanFisikService;
import com.jasamedika.medifirst2000.util.CommonUtil;
import com.jasamedika.medifirst2000.vo.KlasifikasiASAVO;
import com.jasamedika.medifirst2000.vo.PemeriksaanFisikVO;
import com.jasamedika.medifirst2000.vo.PenyulitAnestesiVO;
import com.jasamedika.medifirst2000.vo.PraAnestesiDokterVO;

@Service("PemeriksaanFisikService")
public class PemeriksaanFisikServiceImpl implements PemeriksaanFisikService{
	
	@Autowired
	private BaseConverterImpl<PemeriksaanFisikVO, PemeriksaanFisik> pemeriksaanFisikConverter;
	
	@Autowired
	private BaseConverterImpl<PenyulitAnestesiVO, PenyulitAnestesi> penyulitAnestesiConverter;
	
	@Autowired
	private BaseConverterImpl<PraAnestesiDokterVO, PraAnestesiDokter> praAnestesiDokterConverter;
	
	@Autowired
	private BaseConverterImpl<KlasifikasiASAVO, KlasifikasiASA> klasifikasiASAConverter;
	
	@Autowired
	private PemeriksaanFisikDao pemeriksaanFisikDao;
	
	@Autowired
	private PenyulitAnestesiDao penyulitAnestesiDao;

	@Override
	public PemeriksaanFisikVO add(PemeriksaanFisikVO vo) throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public PemeriksaanFisikVO update(PemeriksaanFisikVO vo) throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public Boolean delete(String key) throws JpaSystemException {
		return null;
	}

	@Override
	public PemeriksaanFisikVO findById(String key) throws JpaSystemException {
		return null;
	}

	@Override
	public List<PemeriksaanFisikVO> findAll() throws JpaSystemException {
		return null;
	}

	@Override
	public Map<String, Object> findAllWithPageAndLimitAndSortByAndDirectionParameter(Integer page, Integer limit,
			String sort, String dir) {
		return null;
	}

	@Override
	public Map<String, Object> savePemeriksaanFisik(PemeriksaanFisikVO vo) {		
		Map <String, Object> result = new HashMap<String, Object>();
		PemeriksaanFisik pemeriksaanFisik = pemeriksaanFisikConverter.transferVOToModel(vo, new PemeriksaanFisik());
		List<PenyulitAnestesi> listPenyulitAnestesi = new ArrayList<PenyulitAnestesi>();
		for(PenyulitAnestesiVO vos : vo.getPenyulitAnestesi())
		{
			PenyulitAnestesi penyulitAnestesi = penyulitAnestesiConverter.transferVOToModel(vos, new PenyulitAnestesi());
			penyulitAnestesi.setPemeriksaanFisik(pemeriksaanFisik);
			listPenyulitAnestesi.add(penyulitAnestesi);
		}
		if (CommonUtil.isNotNullOrEmpty(pemeriksaanFisik.getPenyulitAnestesi())) {

			pemeriksaanFisik.getPenyulitAnestesi().clear();
		}
		pemeriksaanFisik.getPenyulitAnestesi().addAll(listPenyulitAnestesi);
		pemeriksaanFisik.setPraAnestesiDokter(praAnestesiDokterConverter.transferVOToModel(vo.getPraAnestesiDokter(), new PraAnestesiDokter()));
		pemeriksaanFisik.setKlasifikasiASA(klasifikasiASAConverter.transferVOToModel(vo.getKlasifikasiASA(), new KlasifikasiASA()));
		PemeriksaanFisik resultModel = pemeriksaanFisikDao.save(pemeriksaanFisik);
		if(CommonUtil.isNotNullOrEmpty(resultModel)){
			result.put("id", resultModel.getNoRec());
			result.put("Catatan", resultModel.getCatatan());
		}
		return result;
	}

	@Override
	public Map<String, Object> updatePemeriksaanFisik(PemeriksaanFisikVO vo) {
		Map <String, Object> result = new HashMap<String, Object>();
		PemeriksaanFisik pemeriksaanFisik = pemeriksaanFisikConverter.transferVOToModel(vo, new PemeriksaanFisik());
		List<PenyulitAnestesi> penyulitAnestesi = penyulitAnestesiDao.findByNoRec(vo.getNoRec());
		if(CommonUtil.isNotNullOrEmpty(penyulitAnestesi))
		{
			penyulitAnestesiDao.delete(penyulitAnestesi);
		}
		
		List<PenyulitAnestesi> listPenyulitAnestesi = new ArrayList<PenyulitAnestesi>();
		for(PenyulitAnestesiVO vos : vo.getPenyulitAnestesi())
		{
			PenyulitAnestesi modelPenyulitAnestesi = penyulitAnestesiConverter.transferVOToModel(vos, new PenyulitAnestesi());
			modelPenyulitAnestesi.setPemeriksaanFisik(pemeriksaanFisik);
			listPenyulitAnestesi.add(modelPenyulitAnestesi);
		}
		if (CommonUtil.isNotNullOrEmpty(pemeriksaanFisik.getPenyulitAnestesi())) {

			pemeriksaanFisik.getPenyulitAnestesi().clear();
		}
		pemeriksaanFisik.getPenyulitAnestesi().addAll(listPenyulitAnestesi);
		pemeriksaanFisik.setPraAnestesiDokter(praAnestesiDokterConverter.transferVOToModel(vo.getPraAnestesiDokter(), new PraAnestesiDokter()));
		pemeriksaanFisik.setKlasifikasiASA(klasifikasiASAConverter.transferVOToModel(vo.getKlasifikasiASA(), new KlasifikasiASA()));
		PemeriksaanFisik resultModel = pemeriksaanFisikDao.save(pemeriksaanFisik);
		if(CommonUtil.isNotNullOrEmpty(resultModel)){
			result.put("id", resultModel.getNoRec());
			result.put("Catatan", resultModel.getCatatan());
		}
		return result;
		
	}

}
